import RPi.GPIO as GPIO
import time
import Adafruit_WS2801
import Adafruit_GPIO.SPI as SPI

SENSOR_PIN = 23
GPIO.setmode(GPIO.BCM)
GPIO.setup(SENSOR_PIN, GPIO.IN)

SENSOR_PIN2 = 22
GPIO.setmode(GPIO.BCM)
GPIO.setup(SENSOR_PIN2, GPIO.IN)

PIXEL_COUNT = 32
SPI_PORT   = 0
SPI_DEVICE = 0
pixels = Adafruit_WS2801.WS2801Pixels(PIXEL_COUNT, spi=SPI.SpiDev(SPI_PORT, SPI_DEVICE))


def lights(order='up', mode='on'):
    start = 0
    stop = pixels.count()
    direction = 1  
    if order == 'down':
        start = 31
        stop = -1
        direction = -1
    hue = 0
    if mode == 'on':
        hue = 255
    for i in range(start, stop, direction):
        pixels.set_pixel(i, Adafruit_WS2801.RGB_to_color(hue, hue, hue))
        pixels.show()
        time.sleep(0.05)

def up(channel):
    print('unten (1)')
    pixels.clear()
    lights()
    time.sleep(1)
    lights(mode='off')

def down(channel):
    print('oben (2)')
    pixels.clear()
    lights(order='down')
    time.sleep(2)
    lights(order='down', mode='off')

try:
    GPIO.add_event_detect(SENSOR_PIN , GPIO.RISING, callback=up)
    GPIO.add_event_detect(SENSOR_PIN2 , GPIO.RISING, callback=down)
    while True:
        time.sleep(0.001)
except KeyboardInterrupt:
    print "Beende..."
GPIO.cleanup()
